Bug 96563 - [BSW/BXT-P] igt /gem_pwrite / small-gtt* subcases are failing
Summary: [BSW/BXT-P] igt /gem_pwrite / small-gtt* subcases are failing
Status: CLOSED FIXED
Alias: None
Product: DRI
Classification: Unclassified
Component: DRM/Intel (show other bugs)
Version: unspecified
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Elio
QA Contact: Intel GFX Bugs mailing list
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-06-17 16:55 UTC by Elio
Modified: 2017-07-24 22:41 UTC (History)
1 user (show)

See Also:
i915 platform: BSW/CHT, BXT
i915 features: GEM/Other


Attachments
dmesg (243.40 KB, text/plain)
2016-06-17 16:55 UTC, Elio
no flags Details
attachment-10697-0.html (1.59 KB, text/html)
2016-10-13 21:25 UTC, Elio
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Elio 2016-06-17 16:55:15 UTC
Created attachment 124578 [details]
dmesg

The following subtest cases are failing:

igt@gem_pwrite@small-gtt-fbr
igt@gem_pwrite@small-gtt-random
igt@gem_pwrite@small-gtt-forwards
igt@gem_pwrite@small-gtt-backwards

Are failing showing the following message:


IGT-Version: 1.15-g3ce58b6 (x86_64) (Linux: 4.7.0-040700rc2-generic x86_64)
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: Test assertion failure function gem_write, file ioctl_wrappers.c:343:
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: Failed assertion: __gem_write(fd, handle, offset, buf, length) == 0
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: Last errno: 7, Argument list too long
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: error: -7 != 0
Stack trace:
  #0 [__igt_fail_assert+0x101]
  #1 [gem_write+0x91]
  #2 [<unknown>+0x91]
Subtest small-gtt-fbr failed.
**** DEBUG ****
(gem_pwrite:3037) DEBUG: Test requirement passed: gem_mmap__has_wc(fd)
(gem_pwrite:3037) intel-os-DEBUG: Checking 1 surfaces of size 268,439,552 bytes (total 268,443,648) against RAM
(gem_pwrite:3037) intel-os-DEBUG: Test requirement passed: __intel_check_memory(count, size, mode, &required, &total)
(gem_pwrite:3037) igt-core-DEBUG: Test requirement passed: !igt_run_in_simulation()
(gem_pwrite:3037) DEBUG: Forwards
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: Test assertion failure function gem_write, file ioctl_wrappers.c:343:
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: Failed assertion: __gem_write(fd, handle, offset, buf, length) == 0
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: Last errno: 7, Argument list too long
(gem_pwrite:3037) ioctl-wrappers-CRITICAL: error: -7 != 0
****  END  ****
Subtest small-gtt-fbr: FAIL (0.228s)



Configuration:

============================================ 
Kernel version              	: 4.7.0-040700rc2-generic 
Linux distribution          	: Ubuntu 16.04 LTS 
Architecture                	: 64-bit 
Mesa version                	: 11.2.2
xf86-video-intel version    	: 2.99.917 
Xorg-Xserver version        	: 1.18.3 
DRM version                 	: 2.4.67 
VAAPI version               	: Intel i965 driver for Intel(R) CherryView - 1.7.0 
Cairo version               	: [1m[1;31mNot found[0m 
Intel GPU Tools version     	: 1.15-1 <-- [1;33mThis is a generic version of IGT[0m 
Kernel driver in use        	: [1m[1;32mi915[0m 
Hardware acceleration        	:  
Bios revision               	: 4.0 
KSC revision                	: [1m[1;31mNot found[0m <-- [1;33mmaybe the DUT doesn't has this firmware[0m 


 [1m[1;34mHardware information[0m 
============================================ 
Platform                     	:  
Motherboard model            	: Inspiron 15-3552 
Motherboard type             	: 0T14MC Portable 
Motherboard manufacturer     	: Dell Inc. 
CPU family                   	: Pentium 
CPU information              	: Intel(R) Pentium(R) CPU  N3700  @ 1.60GHz 
GPU Card                     	: Intel Corporation Device 22b1 (rev 21) (prog-if 00 [VGA controller]) 
Memory ram                   	: 4 GB 
Maximum memory ram allowed   	: 8 GB 
Display resolution       	:  
CPU's number             	: 4 
Hard drive Capacity 		: 128 GB 


Attaching dmesg
Comment 1 Humberto Israel Perez Rodriguez 2016-06-19 17:07:42 UTC
The following test fail with tne next configuration :


test cases
=================
igt@gem_pwrite@small-gtt-backwards
igt@gem_pwrite@small-gtt-random
igt@gem_pwrite@small-gtt-forwards
igt@gem_pwrite@small-gtt-fbr


kernel : 4.6.1 from http://www.kernel.org/
Graphic stack
--> Component : drm 
         tag : libdrm-2.4.68 
         commit : fc09c5a 
--> Component : mesa 
         tag : mesa-11.2.2 
         commit : 3a9f628 
--> Component : cairo 
         tag : 1.15.2 
         commit : db8a7f1 
--> Component : intel-gpu-tools 
         tag : intel-gpu-tools-1.15 
         commit : 3ce58b6 
Software information
===============================================
Linux distribution                  : Ubuntu 16.04
Architecture                        : 64-bit
Bios revision                       : 138.25
KSC revision                        : 1.12
DMC revision                        : 1.07

Hardware information
===============================================
Platform                            : BXT-P
Motherboard model                   : Broxton P
Motherboard type                    : NOTEBOOK Hand Held
Motherboard manufacturer            : Intel Corp.
CPU family                          : B1
CPU information                     : 06/5c
GPU Card                            : Intel Corporation Device 5a84 (rev 0a) (prog-if 00 [VGA controller])
Comment 2 Humberto Israel Perez Rodriguez 2016-06-29 18:20:29 UTC
The following tests cases fail with the next configuration

Tests cases
============================================
igt@gem_pwrite@small-gtt-forwards
igt@gem_pwrite@small-gtt-backwards
igt@gem_pwrite@small-gtt-random
igt@gem_pwrite@small-gtt-fbr


Software information
============================================
Kernel version                  : 4.7.0-rc4-drm-intel-nightly-ww26-commit-5c244f4+
Linux distribution              : Ubuntu 16.04 LTS
Architecture                    : 64-bit

Hardware information
============================================
Platform                        : BXT-P
Motherboard model               : Broxton P
Motherboard type                : NOTEBOOK Hand Held
Motherboard manufacturer        : Intel Corp.
CPU family                      : B1
CPU information                 : 06/5c
GPU Card                        : Intel Corporation Device 5a84 (rev 0a) (prog-if 00 [VGA controller])
Memory ram                      : 16 GB

Firmwares information
============================================
DMC fw loaded                   : yes
DMC version                     : 1.7
GUC fw loaded                   : SUCCESS
GUC version wanted              : 8.7
GUC version found               : 8.7

 
 --> Component : drm 
	 url : http://cgit.freedesktop.org/mesa/drm 
	 tag : libdrm-2.4.68-9-g625d181 
	 commit : 625d181 
 --> Component : cairo 
	 url : http://cgit.freedesktop.org/cairo 
	 tag : 1.15.2 
	 commit : db8a7f1 
 --> Component : intel-gpu-tools 
	 url : http://cgit.freedesktop.org/xorg/app/intel-gpu-tools 
	 tag : intel-gpu-tools-1.15-54-g88c1f7c 
	 commit : 88c1f7c 

Kernel information
============================================
commit 5c244f4b128c6274755007e080d46e0a61b71534
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 24 16:17:56 2016 +0100

    drm-intel-nightly: 2016y-06m-24d-15h-17m-32s UTC integration manifest
Comment 3 Humberto Israel Perez Rodriguez 2016-07-08 16:47:47 UTC
The following tests fails on APL :

Tests cases
=============================================
igt@gem_pwrite@small-gtt-random
igt@gem_pwrite@small-gtt-backwards
igt@gem_pwrite@small-gtt-forwards
igt@gem_pwrite@small-gtt-fbr


Hardware Information
=============================================
Platform: APL system
Linux distribution: Ubuntu 16.04 64 bits
CPU Name : Intel(R) Genuine Processor @ 1.1 GHz (family: 6, model: 12, stepping: 9) 4 cores
QDF : Q6HE
SoC : B1
CRB : Apollo Lake DDR3L RVP1A FAB1
Reworks : R19, R20
Bios : 144.10
KSC: 1.15

Software Information
===============================================
drm: libdrm-2.4.68-11 7996a87
mesa: mesa-11.2.2 3a9f628
cairo: 1.15.2 db8a7f1
server: xorg-server-1.18.0-443 3762edd 
xf86-video-intel: 2.99.917-674 9154dff
libva: libva-1.7.0-26 c36971c
vaapi-intel-driver: 1.7.0-53 bcde10d
Intel-Gpu-Tools 1.15-87 376b813 

Firmwares information
============================================
DMC fw loaded                   : yes
DMC version                     : 1.7
GUC fw loaded                   : SUCCESS
GUC version wanted              : 8.7
GUC version found               : 8.7


Kernel
===============================================
commit 2fe5da8adcbe5a34830b98c63878eea756e977a2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jul 2 19:32:50 2016 +0100

    drm-intel-nightly: 2016y-07m-02d-18h-31m-39s UTC integration manifest
Comment 4 Chris Wilson 2016-09-09 21:33:16 UTC
This should be working now with both the partial pwrite and partial gtt support.
Comment 5 Luis Botello 2016-10-13 21:24:55 UTC
Issue still present over APL with the following config:

Software Config:
=====================================================
Kernel:
commit f35ed31aea66b3230c366fcba5f3456ae2cb956e
Author: Jani Nikula <jani.nikula@intel.com>
Date:   Mon Oct 10 14:29:09 2016 +0300
    drm-intel-nightly: 2016y-10m-10d-11h-28m-51s UTC integration manifest

drm:
  tag: libdrm-2.4.71
  commit: a44c9c31b7b38b3eedf3d26648f9e68dcc377c4c
mesa:
  tag: mesa-12.0.0
  commit: 8b06176f310f65628ce136b90a99005278ba5e0d
cairo:
  tag: 1.15.2
  commit: db8a7f1697c49ae4942d2aa49eed52dd73dd9c7a
xorg-server-macros:
  tag: util-macros-1.19.0-2-gd7acec2
  commit: d7acec2d3a3abe79814ceb72e2c0d4d95ed31d37
xserver:
  tag: xorg-server-1.18.99.901-76-g97a8353
  commit: 97a8353ec1192d8d3bd2ebb99e5687cb91427e09
xf86-video-intel:
  tag: 2.99.917-712-g696f58f
  commit: 696f58f69f2bac5717d19f7a1a2278fee50a083e
libva:
  tag: libva-1.7.2-38-g3b7e499
  commit: 3b7e4999950a04fabd42edbead8c2f24c6cdf3cf
vaapi-intel-driver:
  tag: 1.7.2-133-gdd73514
  commit: dd73514209d7942f2d8c8b0bbb541fe6884ea1bc

Hardware Config:
========================================================
Platform                        : BXT-P
Motherboard model               : Broxton P
Motherboard type                : NOTEBOOK Hand Held
Motherboard manufacturer        : Intel Corp.
CPU family                      : Other
CPU information                 : 06/5c
GPU Card                        : Intel Corporation Device 5a84 (rev 0a) (prog-if 00 [VGA controller])
Comment 6 Elio 2016-10-13 21:24:59 UTC
Created attachment 127279 [details]
attachment-10697-0.html

See you next year!
Comment 7 Elio 2017-04-05 20:00:10 UTC
Reopening, still failing with following configuration:

Configuration:

Kernel version:
4.11.0-rc5   commit-5bc82ec

Component         : drm
	url       : http://cgit.freedesktop.org/mesa/drm
	tag       : libdrm-2.4.76-16-g6312017
	commit    : 6312017
	author    : Emil Velikov <emil.l.velikov@gmail.com>
	age       : Mon Apr 3 18:01:49 2017 +0100 7 hours ago
	comment   : configure.ac: bring back pthread-stubs check


Component         : mesa
	url       : http://cgit.freedesktop.org/mesa/mesa
	tag       : 17.0-branchpoint-2397-g405ef7b
	commit    : 405ef7b
	author    : Jason Ekstrand <jason@jlekstrand.net>
	age       : Mon Apr 3 16:58:35 2017 -0700 30 minutes ago
	comment   : intel/vec4: Add some fall through comments



Component         : xf86-video-intel
	url       : http://cgit.freedesktop.org/xorg/driver/xf86-video-intel
	tag       : 2.99.917-770-gcb6ba2d
	commit    : cb6ba2d
	author    : Chris Wilson <chris@chris-wilson.co.uk>
	age       : Sat Mar 25 01:21:46 2017 +0000 10 days ago

Component         : libva
	url       : http://cgit.freedesktop.org/libva
	tag       : libva-1.7.3.pre1-85-gefc164d
	commit    : efc164d
	author    : Xiang Haihao <haihao.xiang@intel.com>
	age       : Tue Mar 7 23:42:43 2017 +0800 4 weeks ago
	comment   : Bump libva to 1.8.1.pre1 for development


Component         : intel-driver
	url       : http://cgit.freedesktop.org/vaapi/intel-driver
	tag       : 1.7.3-359-g437cbe0
	commit    : 437cbe0
	author    : Víctor Manuel Jáquez Leal <vjaquez@igalia.com>
	age       : Wed Mar 29 08:29:46 2017 +0800 6 days ago
	comment   : gen8: accept P010 as valid format



Component         : cairo
	url       : http://cgit.freedesktop.org/cairo
	tag       : 1.15.4-11-gcffa452
	commit    : cffa452
	author    : Debarshi Ray <debarshir@freedesktop.org>
	age       : Wed Mar 15 20:26:22 2017 -0700 3 weeks ago
	comment   : doc: Clarify when the device scale is inherited and when 
Component         : xserver
	url       : http://cgit.freedesktop.org/xorg/xserver
	tag       : xorg-server-1.19.0-184-ge4d0757
	commit    : e4d0757
	author    : Adam Jackson <ajax@redhat.com>
	age       : Thu Mar 30 11:32:02 2017 -0400 4 days ago
	comment   : xfree86: Remove driver entity hooks and private



Component         : macros
	url       : https://cgit.freedesktop.org/xorg/util/macros
	tag       : util-macros-1.19.1-2-g39f07f7
	commit    : 39f07f7
	author    : Emil Velikov <emil.veliko@collabora.com>
	age       : Mon Feb 20 10:16:40 2017 +1000 6 weeks ago
	comment   : Rework INSTALL_CMD to touch/echo >&2 only as needed



Component         : intel-gpu-tools
	url       : https://cgit.freedesktop.org/xorg/app/intel-gpu-tools
	tag       : intel-gpu-tools-1.18-56-g56741ce
	commit    : 56741ce
	author    : Chris Wilson <chris@chris-wilson.co.uk>
	age       : Mon Apr 3 19:19:42 2017 +0100 6 hours ago
	comment   : tests/gem_media_fill: Fixup typo



Component         : piglit
	url       : https://cgit.freedesktop.org/piglit
	tag       : piglit-v1
	commit    : 3d1cbd9
	author    : Vinson Lee <vlee@freedesktop.org>
	age       : Mon Apr 3 15:46:33 2017 -0700 2 hours ago
	comment   : glslparsertest: Add test case for FDO bug #100438.
Comment 8 yann 2017-04-11 13:31:08 UTC
Elio, please retry with Chris' patch https://patchwork.freedesktop.org/series/22549/
Comment 9 Chris Wilson 2017-04-13 09:12:08 UTC
commit 4186a2d0e3e200663c2aa999b725e2fa77b49bf8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 13 08:36:13 2017 +0100

    igt/gem_pwrite: Use DOMAIN_WC for access via gem_mmap__wc
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=96563
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
Comment 10 Chris Wilson 2017-04-13 09:13:01 UTC
Also requires:

commit e22d8e3c69a9f432b40baaaf3f894a128fdc2222
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 12 12:01:11 2017 +0100

    drm/i915: Treat WC a separate cache domain
    
    When discussing a new WC mmap, we based the interface upon the
    assumption that GTT was fully coherent. How naive! Commits 3b5724d702ef
    ("drm/i915: Wait for writes through the GTT to land before reading
    back") and ed4596ea992d ("drm/i915/guc: WA to address the Ringbuffer
    coherency issue") demonstrate that writes through the GTT are indeed
    delayed and may be overtaken by direct WC access. To be safe, if
    userspace is mixing WC mmaps with other potential GTT access (pwrite,
    GTT mmaps) it should use set_domain(WC).
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=96563
    Testcase: igt/gem_pwrite/small-gtt*
    Testcase: igt/drv_selftest/coherency
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    Reviewed-by: Joonas Lahtinen <joonas.lahtinen@linux.intel.com>
    Link: http://patchwork.freedesktop.org/patch/msgid/20170412110111.26626-2-chris@chris-wilson.co.uk


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.